Index: mariadb-10.11.11/storage/innobase/include/buf0buf.h
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/include/buf0buf.h
+++ mariadb-10.11.11/storage/innobase/include/buf0buf.h
@@ -35,13 +35,16 @@ Created 11/5/1995 Heikki Tuuri
 #include "assume_aligned.h"
 #include "buf0types.h"
 #ifndef UNIV_INNOCHECKSUM
-#include "ut0byte.h"
 #include "page0types.h"
 #include "log0log.h"
 #include "srv0srv.h"
 #include "transactional_lock_guard.h"
 #include <ostream>
 
+/** The allocation granularity of innodb_buffer_pool_size */
+constexpr size_t innodb_buffer_pool_extent_size=
+  sizeof(size_t) < 8 ? 2 << 20 : 8 << 20;
+
 /** @name Modes for buf_page_get_gen */
 /* @{ */
 #define BUF_GET			10	/*!< get always */
@@ -71,7 +74,7 @@ struct buf_pool_info_t
 	ulint	pool_size;		/*!< Buffer Pool size in pages */
 	ulint	lru_len;		/*!< Length of buf_pool.LRU */
 	ulint	old_lru_len;		/*!< buf_pool.LRU_old_len */
-	ulint	free_list_len;		/*!< Length of buf_pool.free list */
+	ulint	free_list_len;		/*!< free + lazy_allocate_size() */
 	ulint	flush_list_len;		/*!< Length of buf_pool.flush_list */
 	ulint	n_pend_unzip;		/*!< buf_pool.n_pend_unzip, pages
 					pending decompress */
@@ -142,10 +145,8 @@ operator<<(
 	const page_id_t		page_id);
 
 #ifndef UNIV_INNOCHECKSUM
-# define buf_pool_get_curr_size() srv_buf_pool_curr_size
 # define buf_block_free(block) buf_pool.free_block(block)
-
-#define buf_page_get(ID, SIZE, LA, MTR)					\
+# define buf_page_get(ID, SIZE, LA, MTR)                        \
 	buf_page_get_gen(ID, SIZE, LA, NULL, BUF_GET, MTR)
 
 /** Try to buffer-fix a page.
@@ -395,9 +396,6 @@ void
 buf_print_io(
 /*=========*/
 	FILE*	file);	/*!< in: file where to print */
-/** Collect buffer pool metadata.
-@param[out]	pool_info	buffer pool metadata */
-void buf_stats_get_pool_info(buf_pool_info_t *pool_info) noexcept;
 
 /** Refresh the statistics used to print per-second averages. */
 void buf_refresh_io_stats() noexcept;
@@ -427,12 +425,6 @@ counter value in MONITOR_MODULE_BUF_PAGE
 ATTRIBUTE_COLD void buf_page_monitor(const buf_page_t &bpage, bool read)
   noexcept;
 
-/** Calculate aligned buffer pool size based on srv_buf_pool_chunk_unit,
-if needed.
-@param[in]	size	size in bytes
-@return	aligned size */
-ulint buf_pool_size_align(ulint size) noexcept;
-
 /** Verify that post encryption checksum match with the calculated checksum.
 This function should be called only if tablespace contains crypt data metadata.
 @param page       page frame
@@ -549,7 +541,7 @@ public:
   /** buf_pool.LRU status mask in state() */
   static constexpr uint32_t LRU_MASK= 7U << 29;
 
-  /** lock covering the contents of frame */
+  /** lock covering the contents of frame() */
   block_lock lock;
   /** pointer to aligned, uncompressed page frame of innodb_page_size */
   byte *frame;
@@ -559,8 +551,6 @@ public:
   !frame && !zip.data means an active buf_pool.watch */
   page_zip_des_t zip;
 #ifdef UNIV_DEBUG
-  /** whether this->list is in buf_pool.zip_hash; protected by buf_pool.mutex */
-  bool in_zip_hash;
   /** whether this->LRU is in buf_pool.LRU (in_file());
   protected by buf_pool.mutex */
   bool in_LRU_list;
@@ -574,7 +564,7 @@ public:
   /** list member in one of the lists of buf_pool; protected by
   buf_pool.mutex or buf_pool.flush_list_mutex
 
-  state() == NOT_USED: buf_pool.free or buf_pool.withdraw
+  state() == NOT_USED: buf_pool.free
 
   in_file() && oldest_modification():
   buf_pool.flush_list (protected by buf_pool.flush_list_mutex)
@@ -615,7 +605,7 @@ public:
     lock() /* not copied */,
     frame(b.frame), zip(b.zip),
 #ifdef UNIV_DEBUG
-    in_zip_hash(b.in_zip_hash), in_LRU_list(b.in_LRU_list),
+    in_LRU_list(b.in_LRU_list),
     in_page_hash(b.in_page_hash), in_free_list(b.in_free_list),
 #endif /* UNIV_DEBUG */
     list(b.list), LRU(b.LRU), old(b.old), freed_page_clock(b.freed_page_clock),
@@ -632,7 +622,6 @@ public:
     id_= id;
     zip.fix= state;
     oldest_modification_= 0;
-    ut_d(in_zip_hash= false);
     ut_d(in_free_list= false);
     ut_d(in_LRU_list= false);
     ut_d(in_page_hash= false);
@@ -891,10 +880,6 @@ struct buf_block_t{
 					buf_pool.page_hash can point
 					to buf_page_t or buf_block_t */
 #ifdef UNIV_DEBUG
-  /** whether page.list is in buf_pool.withdraw
-  ((state() == NOT_USED)) and the buffer pool is being shrunk;
-  protected by buf_pool.mutex */
-  bool in_withdraw_list;
   /** whether unzip_LRU is in buf_pool.unzip_LRU
   (in_file() && frame && zip.data);
   protected by buf_pool.mutex */
@@ -1022,15 +1007,10 @@ struct buf_block_t{
   @param state    initial state() */
   void initialise(const page_id_t page_id, ulint zip_size, uint32_t state)
     noexcept;
-};
 
-/**********************************************************************//**
-Compute the hash fold value for blocks in buf_pool.zip_hash. */
-/* @{ */
-#define BUF_POOL_ZIP_FOLD_PTR(ptr) (ulint(ptr) >> srv_page_size_shift)
-#define BUF_POOL_ZIP_FOLD(b) BUF_POOL_ZIP_FOLD_PTR((b)->page.frame)
-#define BUF_POOL_ZIP_FOLD_BPAGE(b) BUF_POOL_ZIP_FOLD((buf_block_t*) (b))
-/* @} */
+  /** Calculate the page frame address */
+  IF_DBUG(,inline) byte *frame_address() const noexcept;
+};
 
 /** A "Hazard Pointer" class used to iterate over buf_pool.LRU or
 buf_pool.flush_list. A hazard pointer is a buf_page_t pointer
@@ -1198,59 +1178,62 @@ struct buf_buddy_stat_t {
 /** The buffer pool */
 class buf_pool_t
 {
-  /** A chunk of buffers */
-  struct chunk_t
-  {
-    /** number of elements in blocks[] */
-    size_t size;
-    /** memory allocated for the page frames */
-    unsigned char *mem;
-    /** descriptor of mem */
-    ut_new_pfx_t mem_pfx;
-    /** array of buffer control blocks */
-    buf_block_t *blocks;
-
-    /** Map of first page frame address to chunks[] */
-    using map= std::map<const void*, chunk_t*, std::less<const void*>,
-                        ut_allocator<std::pair<const void* const,chunk_t*>>>;
-    /** Chunk map that may be under construction by buf_resize_thread() */
-    static map *map_reg;
-    /** Current chunk map for lookup only */
-    static map *map_ref;
-
-    /** @return the memory size bytes. */
-    size_t mem_size() const noexcept { return mem_pfx.m_size; }
-
-    /** Register the chunk */
-    void reg() noexcept
-    { map_reg->emplace(map::value_type(blocks->page.frame, this)); }
-
-    /** Allocate a chunk of buffer frames.
-    @param bytes    requested size
-    @return whether the allocation succeeded */
-    inline bool create(size_t bytes) noexcept;
+  /** arrays of buf_block_t followed by page frames;
+  aliged to and repeating every innodb_buffer_pool_extent_size;
+  each extent comprises pages_in_extent[] blocks */
+  alignas(CPU_LEVEL1_DCACHE_LINESIZE) char *memory;
+  /** the allocation of the above memory, possibly including some
+  alignment loss at the beginning */
+  char *memory_unaligned;
+  /** the virtual address range size of memory_unaligned */
+  size_t size_unaligned;
+#ifdef UNIV_PFS_MEMORY
+  /** the "owner thread" of the buffer pool allocation */
+  PSI_thread *owner;
+#endif
+  /** initialized number of block descriptors */
+  size_t n_blocks;
+  /** number of blocks that need to be freed in shrink() */
+  size_t n_blocks_to_withdraw;
+  /** first block to withdraw in shrink() */
+  const buf_page_t *first_to_withdraw;
 
-#ifdef UNIV_DEBUG
-    /** Find a block that points to a ROW_FORMAT=COMPRESSED page
-    @param data  pointer to the start of a ROW_FORMAT=COMPRESSED page frame
-    @return the block
-    @retval nullptr  if not found */
-    const buf_block_t *contains_zip(const void *data) const noexcept
-    {
-      const buf_block_t *block= blocks;
-      for (auto i= size; i--; block++)
-        if (block->page.zip.data == data)
-          return block;
-      return nullptr;
-    }
+  /** amount of memory allocated to the buffer pool and descriptors;
+  protected by mutex */
+  Atomic_relaxed<size_t> size_in_bytes;
 
-    /** Check that all blocks are in a replaceable state.
-    @return address of a non-free block
-    @retval nullptr if all freed */
-    inline const buf_block_t *not_freed() const noexcept;
-#endif /* UNIV_DEBUG */
-  };
 public:
+  /** The requested innodb_buffer_pool_size */
+  size_t size_in_bytes_requested;
+  /** The maximum allowed innodb_buffer_pool_size */
+  size_t size_in_bytes_max;
+
+  /** @return the current size of the buffer pool, in bytes */
+  size_t curr_pool_size() const noexcept { return size_in_bytes; }
+
+  /** @return the current size of the buffer pool, in pages */
+  TPOOL_SUPPRESS_TSAN size_t curr_size() const noexcept { return n_blocks; }
+  /** @return the maximum usable size of the buffer pool, in pages */
+  TPOOL_SUPPRESS_TSAN size_t usable_size() const noexcept
+  { return n_blocks - n_blocks_to_withdraw - UT_LIST_GET_LEN(withdrawn); }
+
+  /** Determine the used size of the buffer pool in bytes.
+  @param n_blocks   size of the buffer pool in blocks
+  @return the size needed for n_blocks in bytes, for innodb_page_size */
+  static size_t blocks_in_bytes(size_t n_blocks) noexcept;
+
+#if defined(DBUG_OFF) && defined(HAVE_MADVISE) && defined(MADV_DODUMP)
+  /** Enable buffers to be dumped to core files.
+
+  A convenience function, not called anyhwere directly however
+  it is left available for gdb or any debugger to call
+  in the event that you want all of the memory to be dumped
+  to a core file.
+
+  @return number of errors found in madvise() calls */
+  static int madvise_do_dump() noexcept;
+#endif
+
   /** Hash cell chain in page_hash_table */
   struct hash_chain
   {
@@ -1258,106 +1241,58 @@ public:
     buf_page_t *first;
   };
 private:
-  /** Withdraw blocks from the buffer pool until meeting withdraw_target.
-  @return whether retry is needed */
-  inline bool withdraw_blocks() noexcept;
-
-  /** Determine if a pointer belongs to a buf_block_t. It can be a pointer to
-  the buf_block_t itself or a member of it.
-  @param ptr    a pointer that will not be dereferenced
-  @return whether the ptr belongs to a buf_block_t struct */
-  bool is_block_field(const void *ptr) const noexcept
-  {
-    const chunk_t *chunk= chunks;
-    const chunk_t *const echunk= chunk + ut_min(n_chunks, n_chunks_new);
-
-    /* TODO: protect chunks with a mutex (the older pointer will
-    currently remain during resize()) */
-    for (; chunk < echunk; chunk++)
-      if (ptr >= reinterpret_cast<const void*>(chunk->blocks) &&
-          ptr < reinterpret_cast<const void*>(chunk->blocks + chunk->size))
-        return true;
-    return false;
-  }
-
-  /** Try to reallocate a control block.
-  @param block  control block to reallocate
-  @return whether the reallocation succeeded */
-  inline bool realloc(buf_block_t *block) noexcept;
+  /** Determine the number of blocks in a buffer pool of a particular size.
+  @param size_in_bytes    innodb_buffer_pool_size in bytes
+  @return number of buffer pool pages */
+  static size_t get_n_blocks(size_t size_in_bytes) noexcept;
+
+  /** The outcome of shrink() */
+  enum shrink_status{SHRINK_DONE= -1, SHRINK_IN_PROGRESS= 0, SHRINK_ABORT};
+
+  /** Attempt to shrink the buffer pool.
+  @param size   requested innodb_buffer_pool_size in bytes
+  @retval whether the shrinking was completed */
+  ATTRIBUTE_COLD shrink_status shrink(size_t size) noexcept;
+
+  /** Finish shrinking the buffer pool.
+  @param size    the new innodb_buffer_pool_size in bytes
+  @param reduced how much the innodb_buffer_pool_size was reduced */
+  inline void shrunk(size_t size, size_t reduced) noexcept;
 
 public:
-  bool is_initialised() const noexcept { return chunks != nullptr; }
+  bool is_initialised() const noexcept { return memory != nullptr; }
 
   /** Create the buffer pool.
   @return whether the creation failed */
-  bool create();
+  bool create() noexcept;
 
   /** Clean up after successful create() */
   void close() noexcept;
 
-  /** Resize from srv_buf_pool_old_size to srv_buf_pool_size. */
-  inline void resize();
+  /** Resize the buffer pool.
+  @param size   requested innodb_buffer_pool_size in bytes
+  @param thd    current connnection */
+  ATTRIBUTE_COLD void resize(size_t size, THD *thd) noexcept;
 
-#ifdef __linux__
   /** Collect garbage (release pages from the LRU list) */
-  inline void garbage_collect();
-#endif
-
-  /** @return whether resize() is in progress */
-  bool resize_in_progress() const noexcept
-  {
-    return UNIV_UNLIKELY(resizing.load(std::memory_order_relaxed));
-  }
+  inline void garbage_collect() noexcept;
 
-  /** @return the current size in blocks */
-  size_t get_n_pages() const noexcept
-  {
-    ut_ad(is_initialised());
-    size_t size= 0;
-    for (auto j= ut_min(n_chunks_new, n_chunks); j--; )
-      size+= chunks[j].size;
-    return size;
-  }
-
-  /** Determine whether a frame is intended to be withdrawn during resize().
+  /** Determine whether a frame needs to be withdrawn during resize().
   @param ptr    pointer within a buf_page_t::frame
+  @param size   size_in_bytes_requested
   @return whether the frame will be withdrawn */
-  bool will_be_withdrawn(const byte *ptr) const noexcept
+  bool will_be_withdrawn(const byte *ptr, size_t size) const noexcept
   {
-    ut_ad(n_chunks_new < n_chunks);
-#ifdef SAFE_MUTEX
-    if (resize_in_progress())
-      mysql_mutex_assert_owner(&mutex);
-#endif /* SAFE_MUTEX */
-
-    for (const chunk_t *chunk= chunks + n_chunks_new,
-         * const echunk= chunks + n_chunks;
-         chunk != echunk; chunk++)
-      if (ptr >= chunk->blocks->page.frame &&
-          ptr < (chunk->blocks + chunk->size - 1)->page.frame + srv_page_size)
-        return true;
-    return false;
+    const char *p= reinterpret_cast<const char*>(ptr);
+    ut_ad(p >= memory);
+    ut_ad(p < memory + size_in_bytes_max);
+    return p >= memory + size;
   }
 
-  /** Determine whether a block is intended to be withdrawn during resize().
+  /** Withdraw a block if needed in case resize() is shrinking.
   @param bpage  buffer pool block
-  @return whether the frame will be withdrawn */
-  bool will_be_withdrawn(const buf_page_t &bpage) const noexcept
-  {
-    ut_ad(n_chunks_new < n_chunks);
-#ifdef SAFE_MUTEX
-    if (resize_in_progress())
-      mysql_mutex_assert_owner(&mutex);
-#endif /* SAFE_MUTEX */
-
-    for (const chunk_t *chunk= chunks + n_chunks_new,
-         * const echunk= chunks + n_chunks;
-         chunk != echunk; chunk++)
-      if (&bpage >= &chunk->blocks->page &&
-          &bpage < &chunk->blocks[chunk->size].page)
-        return true;
-    return false;
-  }
+  @return whether the block was withdrawn */
+  ATTRIBUTE_COLD bool withdraw(buf_page_t &bpage) noexcept;
 
   /** Release and evict a corrupted page.
   @param bpage    x-latched page that was found corrupted
@@ -1371,31 +1306,18 @@ public:
 #ifdef UNIV_DEBUG
   /** Find a block that points to a ROW_FORMAT=COMPRESSED page
   @param data  pointer to the start of a ROW_FORMAT=COMPRESSED page frame
+  @param shift number of least significant address bits to ignore
   @return the block
   @retval nullptr  if not found */
-  const buf_block_t *contains_zip(const void *data) const noexcept
-  {
-    mysql_mutex_assert_owner(&mutex);
-    for (const chunk_t *chunk= chunks, * const end= chunks + n_chunks;
-         chunk != end; chunk++)
-      if (const buf_block_t *block= chunk->contains_zip(data))
-        return block;
-    return nullptr;
-  }
-
+  const buf_block_t *contains_zip(const void *data, size_t shift= 0)
+    const noexcept;
   /** Assert that all buffer pool pages are in a replaceable state */
   void assert_all_freed() noexcept;
 #endif /* UNIV_DEBUG */
 
 #ifdef BTR_CUR_HASH_ADAPT
   /** Clear the adaptive hash index on all pages in the buffer pool. */
-  inline void clear_hash_index() noexcept;
-
-  /** Get a buffer block from an adaptive hash index pointer.
-  This function does not return if the block is not identified.
-  @param ptr  pointer to within a page frame
-  @return pointer to block, never NULL */
-  inline buf_block_t *block_from_ahi(const byte *ptr) const noexcept;
+  void clear_hash_index() noexcept;
 #endif /* BTR_CUR_HASH_ADAPT */
 
   /**
@@ -1418,13 +1340,27 @@ public:
     return empty_lsn;
   }
 
-  /** Determine if a buffer block was created by chunk_t::create().
-  @param block  block descriptor (not dereferenced)
-  @return whether block has been created by chunk_t::create() */
-  bool is_uncompressed(const buf_block_t *block) const noexcept
+  /** Look up the block descriptor for a page frame address.
+  @param ptr   address within a valid page frame
+  @return the corresponding block descriptor */
+  static buf_block_t *block_from(const void *ptr) noexcept;
+
+  /** Access a block while holding the buffer pool mutex.
+  @param pos    position between 0 and get_n_pages()
+  @return the block descriptor */
+  buf_block_t *get_nth_page(size_t pos) const noexcept;
+
+#ifdef UNIV_DEBUG
+  /** Determine if an object is within the curr_pool_size()
+  and associated with an uncompressed page.
+  @param ptr   memory object (not dereferenced)
+  @return whether the object is valid in the current buffer pool */
+  bool is_uncompressed_current(const void *ptr) const noexcept
   {
-    return is_block_field(reinterpret_cast<const void*>(block));
+    const ptrdiff_t d= static_cast<const char*>(ptr) - memory;
+    return d >= 0 && size_t(d) < curr_pool_size();
   }
+#endif
 
 public:
   /** page_fix() mode of operation */
@@ -1456,6 +1392,16 @@ public:
   buf_block_t *page_fix(const page_id_t id) noexcept
   { return page_fix(id, nullptr, FIX_WAIT_READ); }
 
+  /** Validate a block descriptor.
+  @param b     block descriptor that may be invalid after shrink()
+  @param latch page_hash latch for id
+  @param id    page identifier
+  @return b->page.fix() if b->page.id() == id
+  @retval 0 if b is invalid */
+  TRANSACTIONAL_TARGET
+  uint32_t page_guess(buf_block_t *b, page_hash_latch &latch,
+                      const page_id_t id) noexcept;
+
   /** Decompress a page and relocate the block descriptor
   @param b      buffer-fixed compressed-only ROW_FORMAT=COMPRESSED page
   @param chain  hash table chain for b->id().fold()
@@ -1477,7 +1423,6 @@ public:
     buf_page_t *bpage= page_hash.get(page_id, chain);
     if (bpage >= &watch[0] && bpage < &watch[UT_ARR_SIZE(watch)])
     {
-      ut_ad(!bpage->in_zip_hash);
       ut_ad(!bpage->zip.data);
       if (!allow_watch)
         bpage= nullptr;
@@ -1498,7 +1443,6 @@ public:
     ut_ad(bpage.in_file());
     if (&bpage < &watch[0] || &bpage >= &watch[array_elements(watch)])
       return false;
-    ut_ad(!bpage.in_zip_hash);
     ut_ad(!bpage.zip.data);
     return true;
   }
@@ -1539,23 +1483,30 @@ public:
   inline uint32_t watch_remove(buf_page_t *w, hash_chain &chain) noexcept;
 
   /** @return whether less than 1/4 of the buffer pool is available */
-  TPOOL_SUPPRESS_TSAN
-  bool running_out() const noexcept
-  {
-    return !recv_recovery_is_on() &&
-      UT_LIST_GET_LEN(free) + UT_LIST_GET_LEN(LRU) <
-        (n_chunks_new * chunks->size) / 4;
-  }
+  bool running_out() const noexcept;
 
   /** @return whether the buffer pool is running low */
   bool need_LRU_eviction() const noexcept;
 
-  /** @return whether the buffer pool is shrinking */
-  inline bool is_shrinking() const noexcept
+  /** @return number of blocks resize() needs to evict from the buffer pool */
+  size_t is_shrinking() const noexcept
+  {
+    mysql_mutex_assert_owner(&mutex);
+    return n_blocks_to_withdraw + UT_LIST_GET_LEN(withdrawn);
+  }
+
+  /** @return number of blocks in resize() waiting to be withdrawn */
+  size_t to_withdraw() const noexcept
   {
-    return n_chunks_new < n_chunks;
+    mysql_mutex_assert_owner(&mutex);
+    return n_blocks_to_withdraw;
   }
 
+  /** @return the shrinking size of the buffer pool, in bytes
+  @retval 0 if resize() is not shrinking the buffer pool */
+  size_t shrinking_size() const noexcept
+  { return is_shrinking() ? size_in_bytes_requested : 0; }
+
 #ifdef UNIV_DEBUG
   /** Validate the buffer pool. */
   void validate() noexcept;
@@ -1572,7 +1523,6 @@ public:
     mysql_mutex_assert_owner(&mutex);
     ut_ad(bpage->in_LRU_list);
     ut_ad(bpage->in_page_hash);
-    ut_ad(!bpage->in_zip_hash);
     ut_ad(bpage->in_file());
     lru_hp.adjust(bpage);
     lru_scan_itr.adjust(bpage);
@@ -1592,26 +1542,8 @@ public:
 
 	/** @name General fields */
 	/* @{ */
-	ulint		curr_pool_size;	/*!< Current pool size in bytes */
 	ulint		LRU_old_ratio;  /*!< Reserve this much of the buffer
 					pool for "old" blocks */
-#ifdef UNIV_DEBUG
-	ulint		buddy_n_frames; /*!< Number of frames allocated from
-					the buffer pool to the buddy system */
-	ulint		mutex_exit_forbidden; /*!< Forbid release mutex */
-#endif
-	ut_allocator<unsigned char>	allocator;	/*!< Allocator used for
-					allocating memory for the the "chunks"
-					member. */
-	ulint		n_chunks;	/*!< number of buffer pool chunks */
-	ulint		n_chunks_new;	/*!< new number of buffer pool chunks.
-					both n_chunks{,new} are protected under
-					mutex */
-	chunk_t*	chunks;		/*!< buffer pool chunks */
-	chunk_t*	chunks_old;	/*!< old buffer pool chunks to be freed
-					after resizing buffer pool */
-	/** current pool size in pages */
-	Atomic_counter<ulint> curr_size;
 	/** read-ahead request size in pages */
 	Atomic_counter<uint32_t> read_ahead_area;
 
@@ -1723,12 +1655,6 @@ public:
     /** Look up a page in a hash bucket chain. */
     inline buf_page_t *get(const page_id_t id, const hash_chain &chain) const
       noexcept;
-
-    /** Exclusively aqcuire all latches */
-    inline void write_lock_all() noexcept;
-
-    /** Release all latches */
-    inline void write_unlock_all() noexcept;
   };
 
   /** Buffer pool mutex */
@@ -1745,9 +1671,6 @@ public:
   indexed by page_id_t. Protected by both mutex and page_hash.lock_get(). */
   page_hash_table page_hash;
 
-  /** map of block->frame to buf_block_t blocks that belong
-  to buf_buddy_alloc(); protected by buf_pool.mutex */
-  hash_table_t zip_hash;
   /** number of pending unzip() */
   Atomic_counter<ulint> n_pend_unzip;
 
@@ -1878,30 +1801,29 @@ public:
   Set whenever the free list grows, along with a broadcast of done_free.
   Protected by buf_pool.mutex. */
   Atomic_relaxed<bool> try_LRU_scan;
-  /** Whether we have warned to be running out of buffer pool */
-  std::atomic_flag LRU_warned;
 
 	/* @} */
 
 	/** @name LRU replacement algorithm fields */
 	/* @{ */
 
-	UT_LIST_BASE_NODE_T(buf_page_t) free;
-					/*!< base node of the free
-					block list */
+private:
+  /** Whether we have warned to be running out of buffer pool;
+  only modified by buf_flush_page_cleaner():
+  set while holding mutex, cleared while holding flush_list_mutex */
+  Atomic_relaxed<bool> LRU_warned;
+
+  /** withdrawn blocks during resize() */
+  UT_LIST_BASE_NODE_T(buf_page_t) withdrawn;
+
+public:
+  /** list of blocks available for allocate() */
+  UT_LIST_BASE_NODE_T(buf_page_t) free;
+
   /** broadcast each time when the free list grows or try_LRU_scan is set;
   protected by mutex */
   pthread_cond_t done_free;
 
-	UT_LIST_BASE_NODE_T(buf_page_t) withdraw;
-					/*!< base node of the withdraw
-					block list. It is only used during
-					shrinking buffer pool size, not to
-					reuse the blocks will be removed */
-
-	ulint		withdraw_target;/*!< target length of withdraw
-					block list, when withdrawing */
-
 	/** "hazard pointer" used during scan of LRU while doing
 	LRU list batch.  Protected by buf_pool_t::mutex. */
 	LRUHp		lru_hp;
@@ -1942,10 +1864,22 @@ public:
   /** Sentinels to detect if pages are read into the buffer pool while
   a delete-buffering operation is pending. Protected by mutex. */
   buf_page_t watch[innodb_purge_threads_MAX + 1];
+
+  /** Clear LRU_warned */
+  void LRU_warned_clear() noexcept
+  {
+    mysql_mutex_assert_owner(&flush_list_mutex);
+    LRU_warned= false;
+  }
+
   /** Reserve a buffer. */
   buf_tmp_buffer_t *io_buf_reserve(bool wait_for_reads) noexcept
   { return io_buf.reserve(wait_for_reads); }
 
+  /** Try to allocate a block.
+  @return a buffer block
+  @retval nullptr if no blocks are available */
+  buf_block_t *allocate() noexcept;
   /** Remove a block from flush_list.
   @param bpage   buffer pool page */
   void delete_from_flush_list(buf_page_t *bpage) noexcept;
@@ -1968,6 +1902,10 @@ public:
   /** Issue a warning that we could not free up buffer pool pages. */
   ATTRIBUTE_COLD void LRU_warn() noexcept;
 
+  /** Collect buffer pool metadata.
+  @param pool_info    buffer pool metadata */
+  void get_info(buf_pool_info_t *pool_info) noexcept;
+
 private:
   /** Temporary memory for page_compressed and encrypted I/O */
   struct io_buf_t
@@ -1984,9 +1922,6 @@ private:
     /** Reserve a buffer */
     buf_tmp_buffer_t *reserve(bool wait_for_reads) noexcept;
   } io_buf;
-
-  /** whether resize() is in the critical path */
-  std::atomic<bool> resizing;
 };
 
 /** The InnoDB buffer pool */
@@ -2135,24 +2070,6 @@ inline void buf_page_t::set_old(bool old
   this->old= old;
 }
 
-#ifdef UNIV_DEBUG
-/** Forbid the release of the buffer pool mutex. */
-# define buf_pool_mutex_exit_forbid() do {		\
-	mysql_mutex_assert_owner(&buf_pool.mutex);	\
-	buf_pool.mutex_exit_forbidden++;		\
-} while (0)
-/** Allow the release of the buffer pool mutex. */
-# define buf_pool_mutex_exit_allow() do {		\
-	mysql_mutex_assert_owner(&buf_pool.mutex);	\
-	ut_ad(buf_pool.mutex_exit_forbidden--);		\
-} while (0)
-#else
-/** Forbid the release of the buffer pool mutex. */
-# define buf_pool_mutex_exit_forbid() ((void) 0)
-/** Allow the release of the buffer pool mutex. */
-# define buf_pool_mutex_exit_allow() ((void) 0)
-#endif
-
 /**********************************************************************
 Let us list the consistency conditions for different control block states.
 
Index: mariadb-10.11.11/storage/innobase/include/buf0buf.inl
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/include/buf0buf.inl
+++ mariadb-10.11.11/storage/innobase/include/buf0buf.inl
@@ -37,7 +37,7 @@ inline bool buf_page_peek_if_young(const
 	/* FIXME: bpage->freed_page_clock is 31 bits */
 	return((buf_pool.freed_page_clock & ((1UL << 31) - 1))
 	       < (bpage->freed_page_clock
-		  + (buf_pool.curr_size
+		  + (buf_pool.curr_size()
 		     * (BUF_LRU_OLD_RATIO_DIV - buf_pool.LRU_old_ratio)
 		     / (BUF_LRU_OLD_RATIO_DIV * 4))));
 }
Index: mariadb-10.11.11/storage/innobase/include/buf0lru.h
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/include/buf0lru.h
+++ mariadb-10.11.11/storage/innobase/include/buf0lru.h
@@ -55,10 +55,6 @@ bool buf_LRU_free_page(buf_page_t *bpage
 @return true if found and freed */
 bool buf_LRU_scan_and_free_block(ulint limit= ULINT_UNDEFINED);
 
-/** @return a buffer block from the buf_pool.free list
-@retval	NULL	if the free list is empty */
-buf_block_t* buf_LRU_get_free_only();
-
 /** Get a block from the buf_pool.free list.
 If the list is empty, blocks will be moved from the end of buf_pool.LRU
 to buf_pool.free.
Index: mariadb-10.11.11/storage/innobase/include/srv0srv.h
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/include/srv0srv.h
+++ mariadb-10.11.11/storage/innobase/include/srv0srv.h
@@ -223,17 +223,6 @@ extern uint	srv_flush_log_at_timeout;
 extern my_bool	srv_adaptive_flushing;
 extern my_bool	srv_flush_sync;
 
-/** Requested size in bytes */
-extern ulint		srv_buf_pool_size;
-/** Requested buffer pool chunk size */
-extern size_t		srv_buf_pool_chunk_unit;
-/** Scan depth for LRU flush batch i.e.: number of blocks scanned*/
-/** Previously requested size */
-extern ulint	srv_buf_pool_old_size;
-/** Current size as scaling factor for the other components */
-extern ulint	srv_buf_pool_base_size;
-/** Current size in bytes */
-extern ulint	srv_buf_pool_curr_size;
 /** Dump this % of each buffer pool during BP dump */
 extern ulong	srv_buf_pool_dump_pct;
 #ifdef UNIV_DEBUG
@@ -596,7 +585,7 @@ struct export_var_t{
 #endif /* BTR_CUR_HASH_ADAPT */
 	char  innodb_buffer_pool_dump_status[OS_FILE_MAX_PATH + 128];/*!< Buf pool dump status */
 	char  innodb_buffer_pool_load_status[OS_FILE_MAX_PATH + 128];/*!< Buf pool load status */
-	char  innodb_buffer_pool_resize_status[512];/*!< Buf pool resize status */
+	char  innodb_buffer_pool_resize_status[65];/*!< Buf pool resize status */
 	my_bool innodb_buffer_pool_load_incomplete;/*!< Buf pool load incomplete */
 	ulint innodb_buffer_pool_pages_total;	/*!< Buffer pool size */
 	ulint innodb_buffer_pool_bytes_data;	/*!< File bytes used */
Index: mariadb-10.11.11/storage/innobase/log/log0log.cc
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/log/log0log.cc
+++ mariadb-10.11.11/storage/innobase/log/log0log.cc
@@ -1323,7 +1323,11 @@ void log_free_check()
   }
 }
 
-extern void buf_resize_shutdown();
+#ifdef __linux__
+extern void buf_mem_pressure_shutdown() noexcept;
+#else
+inline void buf_mem_pressure_shutdown() noexcept {}
+#endif
 
 /** Make a checkpoint at the latest lsn on shutdown. */
 ATTRIBUTE_COLD void logs_empty_and_mark_files_at_shutdown()
@@ -1341,8 +1345,7 @@ ATTRIBUTE_COLD void logs_empty_and_mark_
 		srv_master_timer.reset();
 	}
 
-	/* Wait for the end of the buffer resize task.*/
-	buf_resize_shutdown();
+	buf_mem_pressure_shutdown();
 	dict_stats_shutdown();
 	btr_defragment_shutdown();
 
Index: mariadb-10.11.11/storage/innobase/log/log0recv.cc
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/log/log0recv.cc
+++ mariadb-10.11.11/storage/innobase/log/log0recv.cc
@@ -1481,34 +1481,18 @@ inline void recv_sys_t::free(const void
   ut_ad(!ut_align_offset(data, ALIGNMENT));
   mysql_mutex_assert_owner(&mutex);
 
-  /* MDEV-14481 FIXME: To prevent race condition with buf_pool.resize(),
-  we must acquire and hold the buffer pool mutex here. */
-  ut_ad(!buf_pool.resize_in_progress());
-
-  auto *chunk= buf_pool.chunks;
-  for (auto i= buf_pool.n_chunks; i--; chunk++)
-  {
-    if (data < chunk->blocks->page.frame)
-      continue;
-    const size_t offs= (reinterpret_cast<const byte*>(data) -
-                        chunk->blocks->page.frame) >> srv_page_size_shift;
-    if (offs >= chunk->size)
-      continue;
-    buf_block_t *block= &chunk->blocks[offs];
-    ut_ad(block->page.frame == page_align(data));
-    ut_ad(block->page.state() == buf_page_t::MEMORY);
-    ut_ad(uint16_t(block->page.free_offset - 1) < srv_page_size);
-    ut_ad(block->page.used_records);
-    if (!--block->page.used_records)
-    {
-      block->page.hash= nullptr;
-      UT_LIST_REMOVE(blocks, block);
-      MEM_MAKE_ADDRESSABLE(block->page.frame, srv_page_size);
-      buf_block_free(block);
-    }
-    return;
+  buf_block_t *block= buf_pool.block_from(data);
+  ut_ad(block->page.frame == page_align(data));
+  ut_ad(block->page.state() == buf_page_t::MEMORY);
+  ut_ad(uint16_t(block->page.free_offset - 1) < srv_page_size);
+  ut_ad(block->page.used_records);
+  if (!--block->page.used_records)
+  {
+    block->page.hash= nullptr;
+    UT_LIST_REMOVE(blocks, block);
+    MEM_MAKE_ADDRESSABLE(block->page.frame, srv_page_size);
+    buf_block_free(block);
   }
-  ut_ad(0);
 }
 
 
@@ -2060,9 +2044,9 @@ ATTRIBUTE_COLD void recv_sys_t::wait_for
   mysql_mutex_lock(&mutex);
   garbage_collect();
   mysql_mutex_lock(&buf_pool.mutex);
-  bool need_more= UT_LIST_GET_LEN(buf_pool.free) < pages;
+  const size_t available= UT_LIST_GET_LEN(buf_pool.free);
   mysql_mutex_unlock(&buf_pool.mutex);
-  if (need_more)
+  if (available < pages)
     buf_flush_sync_batch(lsn);
 }
 
